#!/usr/bin/python3

import sys

zone_file_names = {

    "100090": "Hunter_of_Faydwer.xml",
    "100095": "Hunter_of_Odus.xml",
    "100101": "Hunter_of_Northwest_Antonica.xml",
    "100105": "Hunter_of_Northeast_Antonica.xml",
    "100110": "Hunter_of_Southwest_Antonica.xml",
    "100115": "Hunter_of_Southeast_Antonica.xml",
    "100120": "Hunter_of_The_Planes.xml",
    "100480": "qeytoqrg.xml",
    "101180": "runnyeye.xml",
    "101280": "qey2hh1.xml",
    "101380": "northkarana.xml",
    "101480": "southkarana.xml",
    "101680": "beholder.xml",
    "101880": "paw.xml",
    "102780": "lavastorm.xml",
    "103080": "everfrost.xml",
    "103180": "soldunga.xml",
    "103280": "soldungb.xml",
    "103680": "befallen.xml",
    "103980": "Hunter_of_The_Ruins_of_Old_Paineel.xml",
    "104480": "najena.xml",
    "104580": "qcat.xml",
    "104780": "feerrott.xml",
    "104880": "Hunter_of_Temple_of_Cazic-Thule.xml",
    "105080": "rathemtn.xml",
    "105180": "lakerathe.xml",
    "105780": "lfaydark.xml",
    "105880": "crushbone.xml",
    "105980": "mistmoore.xml",
    "106380": "unrest.xml",
    "106480": "kedge.xml",
    "106580": "guktop.xml",
    "106680": "gukbottom.xml",
    "106880": "butcher.xml",
    "107080": "cauldron.xml",
    "107380": "permafrost.xml",
    "110080": "stonebrunt.xml",
    "110180": "warrens.xml",
    "118180": "jaggedpine.xml",
    "118280": "nedaria.xml",
    "127880": "soldungc.xml",
    "138480": "freeportsewers.xml",
    "139280": "nro.xml",
    "139380": "sro.xml",
    "140780": "highpasshold.xml",
    "140980": "oceanoftears.xml",
    "141480": "toxxulia.xml",
    "141580": "mistythicket.xml",
    "144880": "steamfontmts.xml",
    "151880": "paw.xml",
    "153980": "hole.xml",
    "154880": "cazicthule.xml",
    "158680": "hateplaneb.xml",
    "207880": "fieldofbone.xml",
    "207980": "warslikswood.xml",
    "208180": "Hunter_of_The_Temple_of_Droga.xml",
    "208380": "swampofnohope.xml",
    "208580": "lakeofillomen.xml",
    "208680": "dreadlands.xml",
    "208780": "burningwood.xml",
    "208880": "kaesora.xml",
    "208980": "sebilis.xml",
    "209080": "citymist.xml",
    "209280": "frontiermtns.xml",
    "209480": "emeraldjungle.xml",
    "209580": "trakanon.xml",
    "209680": "timorous.xml",
    "209780": "kurn.xml",
    "210280": "karnor.xml",
    "210380": "chardok.xml",
    "210480": "dalnir.xml",
    "210580": "charasis.xml",
    "210880": "veeshan.xml",
    "210980": "veksar.xml",
    "227780": "chardokb.xml",
    "250880": "veeshan.xml",
    "258180": "droga.xml",
    "260780": "nurga.xml",
    "311080": "iceclad.xml",
    "311180": "frozenshadow.xml",
    "311280": "velketor.xml",
    "311380": "kael.xml",
    "311680": "eastwastes.xml",
    "311780": "cobaltscar.xml",
    "311880": "greatdivide.xml",
    "311980": "wakening.xml",
    "312080": "westwastes.xml",
    "312180": "crystal.xml",
    "312380": "necropolis.xml",
    "312580": "sirens.xml",
    "312980": "thurgadinb.xml",
    "352680": "mischiefplane.xml",
    "380280": "sleeper.xml",
    "380380": "skyshrine.xml",
    "415380": "echo.xml",
    "415480": "acrylia.xml",
    "415680": "paludal.xml",
    "415780": "fungusgrove.xml",
    "415880": "vexthal.xml",
    "416180": "netherbian.xml",
    "416280": "ssratemple.xml",
    "416380": "griegsend.xml",
    "416480": "thedeep.xml",
    "416580": "shadeweaver.xml",
    "416680": "hollowshade.xml",
    "416880": "mseru.xml",
    "417080": "twilight.xml",
    "417180": "thegrey.xml",
    "417280": "tenebrous.xml",
    "417380": "maiden.xml",
    "417480": "dawnshroud.xml",
    "417580": "scarlet.xml",
    "417680": "umbral.xml",
    "417980": "akheva.xml",
    "480980": "grimling.xml",
    "520080": "codecay.xml",
    "520180": "pojustice.xml",
    "520480": "ponightmare.xml",
    "520580": "podisease.xml",
    "520680": "poinnovation.xml",
    "520780": "potorment.xml",
    "520880": "povalor.xml",
    "520980": "bothunder.xml",
    "521080": "postorms.xml",
    "521180": "hohonora.xml",
    "521280": "solrotower.xml",
    "521303": "powar.xml",
    "521480": "potactics.xml",
    "521580": "poair.xml",
    "521680": "powater.xml",
    "521780": "pofire.xml",
    "521880": "poeartha.xml",
    "522080": "hohonorb.xml",
    "522180": "nightmareb.xml",
    "622480": "gunthak.xml",
    "622580": "dulak.xml",
    "622680": "torgiran.xml",
    "622780": "nadox.xml",
    "622880": "hatesfury.xml",
    "701080": "ruja.xml",
    "702180": "taka.xml",
    "703280": "mira.xml",
    "704380": "guka.xml",
    "705480": "mmca.xml",
    "706580": "rujb.xml",
    "707680": "takb.xml",
    "708780": "mirb.xml",
    "709880": "gukb.xml",
    "710980": "mmcb.xml",
    "712080": "rujc.xml",
    "713180": "takc.xml",
    "714280": "mirc.xml",
    "715380": "gukc.xml",
    "716480": "mmcc.xml",
    "717580": "rujd.xml",
    "718680": "takd.xml",
    "719780": "mird.xml",
    "720880": "gukd.xml",
    "721980": "mmcd.xml",
    "723080": "ruje.xml",
    "724180": "take.xml",
    "725280": "mire.xml",
    "726380": "guke.xml",
    "727480": "mmce.xml",
    "728580": "rujf.xml",
    "729680": "takf.xml",
    "730010": "Hunter_of_Deepest_Guk.xml",
    "730020": "Hunter_of_Miragul's_Menagerie.xml",
    "730030": "Hunter_of_Mistmoore's_Catacombs.xml",
    "730040": "Hunter_of_The_Rujarkian_Hills.xml",
    "730050": "Hunter_of_Takish-Hiz.xml",
    "730780": "mirf.xml",
    "731880": "gukf.xml",
    "732980": "mmcf.xml",
    "734080": "rujg.xml",
    "735180": "takg.xml",
    "736280": "mirg.xml",
    "737380": "gukg.xml",
    "738480": "mmcg.xml",
    "739580": "rujh.xml",
    "740680": "takh.xml",
    "741780": "mirh.xml",
    "742880": "gukh.xml",
    "743980": "mmch.xml",
    "745080": "ruji.xml",
    "746180": "taki.xml",
    "747280": "miri.xml",
    "748380": "mmci.xml",
    "749480": "rujj.xml",
    "750580": "takj.xml",
    "751680": "mirj.xml",
    "752780": "mmcj.xml",
    "808000": "qvic.xml",
    "808100": "natimbi.xml",
    "808200": "qinimi.xml",
    "808300": "riwwi.xml",
    "808400": "ferubi.xml",
    "808500": "sn.xml",
    "808600": "barindu.xml",
    "808700": "vxed.xml",
    "808800": "kodtaz.xml",
    "808900": "yxtta.xml",
    "908000": "wallofslaughter.xml",
    "908024": "riftseekers.xml",
    "908100": "dranikscar.xml",
    "908200": "harbingers.xml",
    "908300": "dranikhollowsa.xml",
    "908400": "causeway.xml",
    "908500": "bloodfields.xml",
    "908600": "dranikcatacombsa.xml",
    "908700": "draniksewersa.xml",
    "908800": "dranik.xml",
    "908900": "provinggrounds.xml",
    "1008100": "broodlands.xml",
    "1008200": "delvea.xml",
    "1008300": "delveb.xml",
    "1008400": "stillmoona.xml",
    "1008500": "stillmoonb.xml",
    "1008600": "thundercrest.xml",
    "1008700": "thenest.xml",
    "1108100": "corathus.xml",
    "1108200": "corathusa.xml",
    "1108300": "eastkorlach.xml",
    "1108400": "westkorlach.xml",
    "1108500": "drachnidhive.xml",
    "1108600": "drachnidhivea.xml",
    "1108700": "illsalin.xml",
    "1108800": "dreadspire.xml",
    "1208100": "takishruins.xml",
    "1208200": "elddar.xml",
    "1208300": "arcstone.xml",
    "1208400": "relic.xml",
    "1208500": "theater.xml",
    "1208600": "rage.xml",
    "1308000": "frostcrypt.xml",
    "1308019": "ashengate.xml",
    "1308035": "valdeholm.xml",
    "1308100": "moors.xml",
    "1308200": "stonehive.xml",
    "1308300": "mesa.xml",
    "1308400": "roost.xml",
    "1308500": "steppes.xml",
    "1308600": "sunderock.xml",
    "1308700": "vergalid.xml",
    "1308800": "direwind.xml",
    "1308900": "icefall.xml",
    "1408100": "barren.xml",
    "1408200": "suncrest.xml",
    "1408300": "jardel.xml",
    "1408400": "buriedsea.xml",
    "1408500": "thalassius.xml",
    "1408600": "atiiki.xml",
    "1408700": "kattacastrum.xml",
    "1408800": "silyssar.xml",
    "1508000": "crystallos.xml",
    "1508100": "dragonscale.xml",
    "1508200": "guardian.xml",
    "1508300": "hillsofshade.xml",
    "1508400": "mechanotus.xml",
    "1508500": "mansion.xml",
    "1508600": "steamfactory.xml",
    "1508700": "shipworkshop.xml",
    "1508800": "lopingplains.xml",
    "1508900": "bloodmoon.xml",
    "1578780": "gnomemtn.xml",
    "1645260": "oldfieldofbone.xml",
    "1645360": "oldkaesoraa.xml",
    "1645460": "oldkaesorab.xml",
    "1645560": "oldkurn.xml",
    "1645660": "oldkithicor.xml",
    "1645760": "oldcommons.xml",
    "1646660": "oceangreenhills.xml",
    "1646760": "oceangreenvillage.xml",
    "1646860": "oldblackburrow.xml",
    "1646960": "bertoxtemple.xml",
    "1647060": "discord.xml",
    "1647260": "oldbloodfield.xml",
    "1647460": "olddranik.xml",
    "1647560": "toskirakk.xml",
    "1647660": "korascian.xml",
    "1647760": "rathechamber.xml",
    "1708000": "brellstemple.xml",
    "1708008": "convorteum.xml",
    "1708031": "stonesnake.xml",
    "1708100": "brellsrest.xml",
    "1708200": "coolingchamber.xml",
    "1708300": "pellucid.xml",
    "1708400": "fungalforest.xml",
    "1708500": "arthicrex.xml",
    "1708600": "lichencreep.xml",
    "1708700": "underquarry.xml",
    "1708800": "foundation.xml",
    "1708900": "shiningcity.xml",
    "1870060": "feerrott2.xml",
    "1870160": "thulehouse1.xml",
    "1870260": "thulehouse2.xml",
    "1870360": "housegarden.xml",
    "1870460": "thulelibrary.xml",
    "1870560": "well.xml",
    "1870660": "fallen.xml",
    "1870760": "morellcastle.xml",
    "1870860": "somnium.xml",
    "1870960": "alkabormare.xml",
    "1871060": "miragulmare.xml",
    "1871160": "thuledream.xml",
    "1972460": "argath.xml",
    "1972560": "arelis.xml",
    "1972660": "sarithcity.xml",
    "1972760": "rubak.xml",
    "1972860": "beastdomain.xml",
    "1972960": "resplendent.xml",
    "1973060": "pillarsalra.xml",
    "1973160": "windsong.xml",
    "1973260": "cityofbronze.xml",
    "1973360": "sepulcher.xml",
    "2075280": "shardslanding.xml",
    "2075381": "xorbb.xml",
    "2075480": "kaelshard.xml",
    "2075580": "eastwastesshard.xml",
    "2075680": "crystalshard.xml",
    "2075780": "breedinggrounds.xml",
    "2075880": "eviltree.xml",
    "2075980": "grelleth.xml",
    "2076080": "chapterhouse.xml",
    "2076375": "chelsithreborn.xml",
    "2076455": "poshadow.xml",
    "2076540": "heartoffear.xml",
    "2104370": "neriakd.xml",
    "2104371": "neriakd2.xml",
    "2177070": "bixiewarfront.xml",
    "2177071": "bixiewarfront2.xml",
    "2177170": "deadhills.xml",
    "2177270": "ethernere.xml",
    "2177271": "ethernere2.xml",
    "2177570": "towerofrot.xml",
    "2177670": "arginhiz.xml",
    "2277880": "arxmentis.xml",
    "2277980": "brotherisland.xml",
    "2278080": "kattacastrumb.xml",
    "2278180": "dredge.xml",
    "2278280": "endlesscaverns.xml",
    "2278380": "thuliasaur.xml",
    "2278480": "degmar.xml",
    "2278580": "tempesttemple.xml",
    "2320180": "hateplane.xml",
    "2320190": "fearplane.xml",
    "2377780": "exalted.xml",
    "2379580": "cosul.xml",
    "2379680": "codecayb.xml",
    "2379780": "exaltedb.xml",
    "2379880": "pohealth.xml",
    "2478880": "drogab.xml",
    "2479080": "scorchedwoods.xml",
    "2479180": "frontiermtnsb.xml",
    "2479380": "korshaext.xml",
    "2479480": "lceanium.xml",
    "2479980": "korshaint.xml",
    "2480080": "chardoktwo.xml",
    "2578980": "charasisb.xml",
    "2579280": "gorowyn.xml",
    "2581380": "charasistwo.xml",
    "2581480": "skyfiretwo.xml",
    "2581580": "overtheretwo.xml",
    "2581680": "veeshantwo.xml",
    "2681790": "trialsofsmoke.xml",
    "2681880": "stratos.xml",
    "2681980": "aalishai.xml",
    "2682080": "empyr.xml",
    "2682180": "esianti.xml",
    "2682280": "mearatas.xml",
    "2782480": "eastwastestwo.xml",
    "2782580": "frozenshadowtwo.xml",
    "2782680": "crystaltwoa.xml",
    "2782780": "greatdividetwo.xml",
    "2782880": "velketortwo.xml",
    "2782980": "kaeltwo.xml",
    "2783080": "crystaltwob.xml",
    "2807101": "cobaltscartwo.xml",
    "2807201": "westwastestwo.xml",
    "2807301": "templeveeshantwo.xml",
    "2807401": "necropolistwo.xml",
    "2807501": "skyshrinetwo.xml",
    "2807601": "sleepertwo.xml",

}

# get hunter sets
hunter_sets = {}
with open ('/mnt/win_backup/everquest/Resources/Achievements/AchievementsClient.txt', 'rt') as f:
    for l in f:
        ln = l.strip ().split ('^')
        set_number = ln[0]
        set_name = ln[1]
        if set_name.startswith ('Hunter of '):
            hunter_sets[set_number] = { 'name':set_name, 'checklist':[], 'filename':None }

# get individual checks
with open ('/mnt/win_backup/everquest/Resources/Achievements/AchievementComponentsClient.txt', 'rt') as f:
    for l in f:
        ln = l.strip ().split ('^')
        set_number = ln[0]
        check_name = ln[4]
        if set_number in hunter_sets:
            hunter_sets[set_number]['checklist'].append (check_name)

# get zone filenames
for set_number in hunter_sets:
    if set_number in zone_file_names:
        hunter_sets[set_number]['filename'] = zone_file_names[set_number]

trtable = str.maketrans (',-`', '...')
for e in hunter_sets:
    if hunter_sets[e]['filename'] is None:
        print ('missing filename for set ', e, hunter_sets[e]['name'])
    else:
        with open (hunter_sets[e]['filename'], 'at') as f:
            f.write ('<?xml version="1.0" encoding="UTF-8"?>\n')
            f.write ('<!DOCTYPE seqfilters SYSTEM "seqfilters.dtd">\n')
            f.write ('<!-- ' + hunter_sets[e]['name'] + ' -->\n')
            f.write ('<seqfilters>\n')
            f.write ('    <section name="Caution">\n')
            for named in hunter_sets[e]['checklist']:
                f.write ('        <oldfilter><regex>Name:.*' + named.translate (trtable) + '</regex></oldfilter>\n')
            f.write ('    </section>\n')
            f.write ('</seqfilters>\n')
            f.close ()
